# coding: utf-8

"""

    # Authentication  <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 0.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class MatchEntityJsonldDossier(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'context': 'OneOfMatchEntityJsonldDossierContext',
        'id': 'str',
        'type': 'str',
        'competition': 'AnyOfMatchEntityJsonldDossierCompetition',
        'home': 'AnyOfMatchEntityJsonldDossierHome',
        'away': 'AnyOfMatchEntityJsonldDossierAway'
    }

    attribute_map = {
        'context': '@context',
        'id': '@id',
        'type': '@type',
        'competition': 'competition',
        'home': 'home',
        'away': 'away'
    }

    def __init__(self, context=None, id=None, type=None, competition=None, home=None, away=None):  # noqa: E501
        """MatchEntityJsonldDossier - a model defined in Swagger"""  # noqa: E501
        self._context = None
        self._id = None
        self._type = None
        self._competition = None
        self._home = None
        self._away = None
        self.discriminator = None
        if context is not None:
            self.context = context
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if competition is not None:
            self.competition = competition
        if home is not None:
            self.home = home
        if away is not None:
            self.away = away

    @property
    def context(self):
        """Gets the context of this MatchEntityJsonldDossier.  # noqa: E501


        :return: The context of this MatchEntityJsonldDossier.  # noqa: E501
        :rtype: OneOfMatchEntityJsonldDossierContext
        """
        return self._context

    @context.setter
    def context(self, context):
        """Sets the context of this MatchEntityJsonldDossier.


        :param context: The context of this MatchEntityJsonldDossier.  # noqa: E501
        :type: OneOfMatchEntityJsonldDossierContext
        """

        self._context = context

    @property
    def id(self):
        """Gets the id of this MatchEntityJsonldDossier.  # noqa: E501


        :return: The id of this MatchEntityJsonldDossier.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this MatchEntityJsonldDossier.


        :param id: The id of this MatchEntityJsonldDossier.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this MatchEntityJsonldDossier.  # noqa: E501


        :return: The type of this MatchEntityJsonldDossier.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this MatchEntityJsonldDossier.


        :param type: The type of this MatchEntityJsonldDossier.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def competition(self):
        """Gets the competition of this MatchEntityJsonldDossier.  # noqa: E501


        :return: The competition of this MatchEntityJsonldDossier.  # noqa: E501
        :rtype: AnyOfMatchEntityJsonldDossierCompetition
        """
        return self._competition

    @competition.setter
    def competition(self, competition):
        """Sets the competition of this MatchEntityJsonldDossier.


        :param competition: The competition of this MatchEntityJsonldDossier.  # noqa: E501
        :type: AnyOfMatchEntityJsonldDossierCompetition
        """

        self._competition = competition

    @property
    def home(self):
        """Gets the home of this MatchEntityJsonldDossier.  # noqa: E501


        :return: The home of this MatchEntityJsonldDossier.  # noqa: E501
        :rtype: AnyOfMatchEntityJsonldDossierHome
        """
        return self._home

    @home.setter
    def home(self, home):
        """Sets the home of this MatchEntityJsonldDossier.


        :param home: The home of this MatchEntityJsonldDossier.  # noqa: E501
        :type: AnyOfMatchEntityJsonldDossierHome
        """

        self._home = home

    @property
    def away(self):
        """Gets the away of this MatchEntityJsonldDossier.  # noqa: E501


        :return: The away of this MatchEntityJsonldDossier.  # noqa: E501
        :rtype: AnyOfMatchEntityJsonldDossierAway
        """
        return self._away

    @away.setter
    def away(self, away):
        """Sets the away of this MatchEntityJsonldDossier.


        :param away: The away of this MatchEntityJsonldDossier.  # noqa: E501
        :type: AnyOfMatchEntityJsonldDossierAway
        """

        self._away = away

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MatchEntityJsonldDossier, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MatchEntityJsonldDossier):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
